<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMCOTicket ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMCOTicket
 * @subpackage Arrays
 */
class ArrayOfMCOTicket extends AbstractStructArrayBase
{
    /**
     * The MCOTicket
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\MCOTicket[]
     */
    public $MCOTicket;
    /**
     * Constructor method for ArrayOfMCOTicket
     * @uses ArrayOfMCOTicket::setMCOTicket()
     * @param \App|C\StructType\MCOTicket[] $mCOTicket
     */
    public function __construct(array $mCOTicket = array())
    {
        $this
            ->setMCOTicket($mCOTicket);
    }
    /**
     * Get MCOTicket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\MCOTicket[]|null
     */
    public function getMCOTicket()
    {
        return isset($this->MCOTicket) ? $this->MCOTicket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMCOTicket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMCOTicket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMCOTicketForArrayConstraintsFromSetMCOTicket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMCOTicketMCOTicketItem) {
            // validation for constraint: itemType
            if (!$arrayOfMCOTicketMCOTicketItem instanceof \App|C\StructType\MCOTicket) {
                $invalidValues[] = is_object($arrayOfMCOTicketMCOTicketItem) ? get_class($arrayOfMCOTicketMCOTicketItem) : sprintf('%s(%s)', gettype($arrayOfMCOTicketMCOTicketItem), var_export($arrayOfMCOTicketMCOTicketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MCOTicket property can only contain items of type \App|C\StructType\MCOTicket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MCOTicket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\MCOTicket[] $mCOTicket
     * @return \App|C\ArrayType\ArrayOfMCOTicket
     */
    public function setMCOTicket(array $mCOTicket = array())
    {
        // validation for constraint: array
        if ('' !== ($mCOTicketArrayErrorMessage = self::validateMCOTicketForArrayConstraintsFromSetMCOTicket($mCOTicket))) {
            throw new \InvalidArgumentException($mCOTicketArrayErrorMessage, __LINE__);
        }
        if (is_null($mCOTicket) || (is_array($mCOTicket) && empty($mCOTicket))) {
            unset($this->MCOTicket);
        } else {
            $this->MCOTicket = $mCOTicket;
        }
        return $this;
    }
    /**
     * Add item to MCOTicket value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\MCOTicket $item
     * @return \App|C\ArrayType\ArrayOfMCOTicket
     */
    public function addToMCOTicket(\App|C\StructType\MCOTicket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\MCOTicket) {
            throw new \InvalidArgumentException(sprintf('The MCOTicket property can only contain items of type \App|C\StructType\MCOTicket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MCOTicket[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\MCOTicket|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\MCOTicket|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\MCOTicket|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\MCOTicket|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\MCOTicket|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MCOTicket
     */
    public function getAttributeName()
    {
        return 'MCOTicket';
    }
}
