<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ETTicket StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ETTicket
 * @subpackage Structs
 */
class ETTicket extends AbstractTicket
{
    /**
     * The ConjunctiveTicketNumbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring
     */
    public $ConjunctiveTicketNumbers;
    /**
     * The Coupons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfETCoupon
     */
    public $Coupons;
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETTicketDetails
     */
    public $Details;
    /**
     * The ExchangedDocumentNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExchangedDocumentNumber;
    /**
     * The RefETTicketFare
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefETTicketFare;
    /**
     * The RefPassenger
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefPassenger;
    /**
     * Constructor method for ETTicket
     * @uses ETTicket::setConjunctiveTicketNumbers()
     * @uses ETTicket::setCoupons()
     * @uses ETTicket::setDetails()
     * @uses ETTicket::setExchangedDocumentNumber()
     * @uses ETTicket::setRefETTicketFare()
     * @uses ETTicket::setRefPassenger()
     * @param \App|C\ArrayType\ArrayOfstring $conjunctiveTicketNumbers
     * @param \App|C\ArrayType\ArrayOfETCoupon $coupons
     * @param \App|C\StructType\ETTicketDetails $details
     * @param string $exchangedDocumentNumber
     * @param string $refETTicketFare
     * @param string $refPassenger
     */
    public function __construct(\App|C\ArrayType\ArrayOfstring $conjunctiveTicketNumbers = null, \App|C\ArrayType\ArrayOfETCoupon $coupons = null, \App|C\StructType\ETTicketDetails $details = null, $exchangedDocumentNumber = null, $refETTicketFare = null, $refPassenger = null)
    {
        $this
            ->setConjunctiveTicketNumbers($conjunctiveTicketNumbers)
            ->setCoupons($coupons)
            ->setDetails($details)
            ->setExchangedDocumentNumber($exchangedDocumentNumber)
            ->setRefETTicketFare($refETTicketFare)
            ->setRefPassenger($refPassenger);
    }
    /**
     * Get ConjunctiveTicketNumbers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring|null
     */
    public function getConjunctiveTicketNumbers()
    {
        return isset($this->ConjunctiveTicketNumbers) ? $this->ConjunctiveTicketNumbers : null;
    }
    /**
     * Set ConjunctiveTicketNumbers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring $conjunctiveTicketNumbers
     * @return \App|C\StructType\ETTicket
     */
    public function setConjunctiveTicketNumbers(\App|C\ArrayType\ArrayOfstring $conjunctiveTicketNumbers = null)
    {
        if (is_null($conjunctiveTicketNumbers) || (is_array($conjunctiveTicketNumbers) && empty($conjunctiveTicketNumbers))) {
            unset($this->ConjunctiveTicketNumbers);
        } else {
            $this->ConjunctiveTicketNumbers = $conjunctiveTicketNumbers;
        }
        return $this;
    }
    /**
     * Get Coupons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfETCoupon|null
     */
    public function getCoupons()
    {
        return isset($this->Coupons) ? $this->Coupons : null;
    }
    /**
     * Set Coupons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfETCoupon $coupons
     * @return \App|C\StructType\ETTicket
     */
    public function setCoupons(\App|C\ArrayType\ArrayOfETCoupon $coupons = null)
    {
        if (is_null($coupons) || (is_array($coupons) && empty($coupons))) {
            unset($this->Coupons);
        } else {
            $this->Coupons = $coupons;
        }
        return $this;
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETTicketDetails|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\ETTicketDetails $details
     * @return \App|C\StructType\ETTicket
     */
    public function setDetails(\App|C\StructType\ETTicketDetails $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Get ExchangedDocumentNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExchangedDocumentNumber()
    {
        return isset($this->ExchangedDocumentNumber) ? $this->ExchangedDocumentNumber : null;
    }
    /**
     * Set ExchangedDocumentNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $exchangedDocumentNumber
     * @return \App|C\StructType\ETTicket
     */
    public function setExchangedDocumentNumber($exchangedDocumentNumber = null)
    {
        // validation for constraint: string
        if (!is_null($exchangedDocumentNumber) && !is_string($exchangedDocumentNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($exchangedDocumentNumber, true), gettype($exchangedDocumentNumber)), __LINE__);
        }
        if (is_null($exchangedDocumentNumber) || (is_array($exchangedDocumentNumber) && empty($exchangedDocumentNumber))) {
            unset($this->ExchangedDocumentNumber);
        } else {
            $this->ExchangedDocumentNumber = $exchangedDocumentNumber;
        }
        return $this;
    }
    /**
     * Get RefETTicketFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefETTicketFare()
    {
        return isset($this->RefETTicketFare) ? $this->RefETTicketFare : null;
    }
    /**
     * Set RefETTicketFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refETTicketFare
     * @return \App|C\StructType\ETTicket
     */
    public function setRefETTicketFare($refETTicketFare = null)
    {
        // validation for constraint: string
        if (!is_null($refETTicketFare) && !is_string($refETTicketFare)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refETTicketFare, true), gettype($refETTicketFare)), __LINE__);
        }
        if (is_null($refETTicketFare) || (is_array($refETTicketFare) && empty($refETTicketFare))) {
            unset($this->RefETTicketFare);
        } else {
            $this->RefETTicketFare = $refETTicketFare;
        }
        return $this;
    }
    /**
     * Get RefPassenger value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefPassenger()
    {
        return isset($this->RefPassenger) ? $this->RefPassenger : null;
    }
    /**
     * Set RefPassenger value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refPassenger
     * @return \App|C\StructType\ETTicket
     */
    public function setRefPassenger($refPassenger = null)
    {
        // validation for constraint: string
        if (!is_null($refPassenger) && !is_string($refPassenger)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refPassenger, true), gettype($refPassenger)), __LINE__);
        }
        if (is_null($refPassenger) || (is_array($refPassenger) && empty($refPassenger))) {
            unset($this->RefPassenger);
        } else {
            $this->RefPassenger = $refPassenger;
        }
        return $this;
    }
}
